// third_party/blink/public/mojom/compute_pressure/web_pressure_manager_automation.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_COMPUTE_PRESSURE_WEB_PRESSURE_MANAGER_AUTOMATION_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_COMPUTE_PRESSURE_WEB_PRESSURE_MANAGER_AUTOMATION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/compute_pressure/web_pressure_manager_automation.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/compute_pressure/web_pressure_manager_automation.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/compute_pressure/web_pressure_manager_automation.mojom-forward.h"  // IWYU pragma: export
#include "services/device/public/mojom/pressure_manager.mojom-forward.h"
#include "services/device/public/mojom/pressure_update.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::test::mojom {

class WebPressureManagerAutomationProxy;

template <typename ImplRefTraits>
class WebPressureManagerAutomationStub;

class WebPressureManagerAutomationRequestValidator;
class WebPressureManagerAutomationResponseValidator;


class BLINK_COMMON_EXPORT WebPressureManagerAutomation
    : public WebPressureManagerAutomationInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = WebPressureManagerAutomationInterfaceBase;
  using Proxy_ = WebPressureManagerAutomationProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebPressureManagerAutomationStub<ImplRefTraits>;

  using RequestValidator_ = WebPressureManagerAutomationRequestValidator;
  using ResponseValidator_ = WebPressureManagerAutomationResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateVirtualPressureSourceMinVersion = 0,
    kRemoveVirtualPressureSourceMinVersion = 0,
    kUpdateVirtualPressureSourceStateMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateVirtualPressureSource_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct RemoveVirtualPressureSource_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct UpdateVirtualPressureSourceState_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~WebPressureManagerAutomation() = default;


  using CreateVirtualPressureSourceCallback = base::OnceCallback<void(CreateVirtualPressureSourceResult)>;
  
  virtual void CreateVirtualPressureSource(::device::mojom::PressureSource source, ::device::mojom::VirtualPressureSourceMetadataPtr metadata, CreateVirtualPressureSourceCallback callback) = 0;


  using RemoveVirtualPressureSourceCallback = base::OnceCallback<void()>;
  
  virtual void RemoveVirtualPressureSource(::device::mojom::PressureSource source, RemoveVirtualPressureSourceCallback callback) = 0;


  using UpdateVirtualPressureSourceStateCallback = base::OnceCallback<void(UpdateVirtualPressureSourceStateResult)>;
  
  virtual void UpdateVirtualPressureSourceState(::device::mojom::PressureSource source, ::device::mojom::PressureState state, UpdateVirtualPressureSourceStateCallback callback) = 0;
};



class BLINK_COMMON_EXPORT WebPressureManagerAutomationProxy
    : public WebPressureManagerAutomation {
 public:
  using InterfaceType = WebPressureManagerAutomation;

  explicit WebPressureManagerAutomationProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateVirtualPressureSource(::device::mojom::PressureSource source, ::device::mojom::VirtualPressureSourceMetadataPtr metadata, CreateVirtualPressureSourceCallback callback) final;
  
  void RemoveVirtualPressureSource(::device::mojom::PressureSource source, RemoveVirtualPressureSourceCallback callback) final;
  
  void UpdateVirtualPressureSourceState(::device::mojom::PressureSource source, ::device::mojom::PressureState state, UpdateVirtualPressureSourceStateCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT WebPressureManagerAutomationStubDispatch {
 public:
  static bool Accept(WebPressureManagerAutomation* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebPressureManagerAutomation* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebPressureManagerAutomation>>
class WebPressureManagerAutomationStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebPressureManagerAutomationStub() = default;
  ~WebPressureManagerAutomationStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebPressureManagerAutomationStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebPressureManagerAutomationStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT WebPressureManagerAutomationRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT WebPressureManagerAutomationResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::test::mojom

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_COMPUTE_PRESSURE_WEB_PRESSURE_MANAGER_AUTOMATION_MOJOM_H_